@echo off

rem IsDirectory.bat
rem 2008-10-01
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

rem This script returns 1 if the specified file mask is a directory.
rem Otherwise it returns 0.

  SetLocal EnableDelayedExpansion

  set scriptDir=%~d0%~p0
  set scriptName=%~n0%~x0

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% == 1 (
    rem Double-quotes are needed below to handle '&' in file
    rem and directory names.
    set spec="%~1"

    rem Double-quotes are already included in variable.
    call :run !spec!
  ) else (
    call :usage
  )

  goto :end

:run
  rem Double-quotes are needed below to handle '&' in file
  rem and directory names.
  set spec="%~1"
  set result=0

  set pathEnd=%spec:~-2%
  set pathEnd=%pathEnd:~0,1%

  if not "%pathEnd%" == "\" set spec=%spec%\

  if exist %spec% (

rem Could potentially update this script to return the following codes
rem on error.

rem Error Codes
rem   -1 File/dir does not exist.
rem   -2 No permission to access directory.

rem Test for directory permission denied by doing a dir output.
rem If "File Not Found" on standard error, then permission denied.
rem Need a permision denied file to test as well.

    rem Variable already contains double-quotes.
rem    dir /a:d %spec% > NUL 2>&1
rem    set error=!ERRORLEVEL!

rem    if !error! equ 0 (
rem      echo 1
rem    ) else (
rem      echo 0
rem    )

    echo 1
  ) else (
    echo 0
  )

  goto :EOF

:usage
  echo   Usage: "%scriptName%" "path"
  goto :EOF

:end
