@echo off

rem SetVariableToOutput.bat
rem 2008-06-06
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

rem This script is not entirely concurrent safe, because
rem essentially OutputVariable is going to be shared by
rem nature. But we make it as concurrent safe as possible.

  SetLocal EnableDelayedExpansion

  rem Set it to "on" to see debug output.
  set DEBUG=off

  set scriptDir=%~d0%~p0
  set scriptName=%~n0%~x0

  call SetNumberOfArguments.bat %* 
  if %NumberOfArguments% == 0 goto :help

:loop
  set SVTO_quickTmp=%temp%\%scriptName%.%random%.quick.tmp

  if "%DEBUG%" == "on" (
    echo SVTO_quickTemp = "%SVTO_quickTmp%" 1>&2
  )

  if exist "%SVTO_quickTmp%" goto :loop

  call GetTempPathName.bat %~n0 .exec.bat > "%SVTO_quickTmp%"
  set /p SVTO_tempExec=< "%SVTO_quickTmp%"

  if "%DEBUG%" == "on" (
    echo SVTO_tempExec = "%SVTO_tempExec%" 1>&2
  )

  if "%SVTO_tempExec%" == "" goto :loop

  call GetTempPathName.bat %~n0 .tmp > "%SVTO_quickTmp%"
  set /p SVTO_tempFile=< "%SVTO_quickTmp%"

  if "%DEBUG%" == "on" (
    echo SVTO_tempFile = "%SVTO_tempFile%" 1>&2
  )

  if "%SVTO_tempFile%" == "" goto :loop

  del "%SVTO_quickTmp%"

  set cmd=cmd /s /c %*

  rem Do not use parenthesis in following if statement to handle
  rem parenthesis in variable.
  if "%DEBUG%" == "on" echo cmd = "%cmd%" 1>&2

  rem Do not add a space after the cmd variable below.
  rem But it causes problems if the end of %cmd%
  rem is a number (e.g. 2>).
  echo %cmd%> "%SVTO_tempExec%"
  call "%SVTO_tempExec%" > "%SVTO_tempFile%"

  EndLocal & (
    set /p OutputVariable=< "%SVTO_tempFile%"
    set SVTO_tempFile=%SVTO_tempFile%
    set SVTO_tempExec=%SVTO_tempExec%
  )

  rem These two variable names must be very unique.
  del "%SVTO_tempFile%"
  del "%SVTO_tempExec%"
  goto :end

:help
  echo   Usage: "%scriptName%" command 1>&2

:end
