@echo off

rem TakeControlDirContent.cmd
rem 2020-01-12
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  SetLocal EnableDelayedExpansion

  set scriptPath=%~d0%~p0
  set scriptName=%~n0%~x0
  set path=%scriptPath%;%path%

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% == 0 (
    call :usage
  ) else (
    call :loop %*
  )
  goto :end

:loop
  if ?%1? == ?? goto :EOF
  rem Following statement needs double-quote to handle '&'
  set spec="%~1"

  rem spec already contains double-quotes. Leave double-quote off.
  call SetVariableToOutput.bat IsDirectory.bat %spec%
  set result=%OutputVariable%

  rem spec already contains double-quotes. Leave double-quote off.
  if %result% == 1 (
    call :processDir %spec%
  ) else (
    echo %spec% is not a directory. 1>&2
  )

  shift
  goto :loop

:processDir
  rem Following statement needs double-quote to handle '&'
  set spec="%~1"

  rem spec already contains double-quotes. Leave double-quote off.
  for %%f in (%spec%\*) do call TakeControl.bat "%%f"
  for /D %%d in (%spec%\*) do call TakeControlOfContent.bat "%%d"

  goto :EOF

:usage
  echo   Usage: "%scriptName" "file/dir 1" [ . . . "file/dir N" ] 1>&2
  goto :EOF

:end
